﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Util;

namespace BizDemoServer
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }


        string SendMess = "";
        private void StartTcpServer()
        {
            TcpListener Listener = null;
            NetworkStream NS = null;

            StreamReader SR = null;
            StreamWriter SW = null;

            TcpClient client = null;

            int PORT = 5555;

            try
            {
                Listener = new TcpListener(PORT);
                Listener.Start(); // Listener 동작 시작

                while (true)
                {
                    client = Listener.AcceptTcpClient();
                    NS = client.GetStream(); // 소켓에서 메시지를 가져오는 스트림
                    SR = new StreamReader(NS, Encoding.UTF8); // Get message
                    SW = new StreamWriter(NS, Encoding.UTF8); // Send message

                    string GetMessage = string.Empty;

                    while (client.Connected == true) //클라이언트 메시지받기
                    {
                        if (SR.Peek() > 0)
                        {
                            GetMessage = SR.ReadLine();
                            dbg.AddMsg(GetMessage); // 메시지 보내기
                            SW.Flush();
                        }
                        if(SendMess!="")
                        {
                            SW.WriteLine(SendMess);
                            SendMess = "";
                        }

                    }
                }
            }
            catch (Exception e)
            {
                System.Console.WriteLine(e.Message);
            }
            finally
            {
                SW.Close();
                SR.Close();
                client.Close();
                NS.Close();
            }
        }



        UDPserver udpClient;

        private void MainForm_Load(object sender, EventArgs e)
        {
            udpClient = new UDPserver();
            udpClient.Start(9900);

            StreamReader srUDP = new StreamReader("./udp.txt");
            StreamReader srTCP = new StreamReader("./tcp.txt");

            while (!srUDP.EndOfStream) cbUDP.Items.Add(srUDP.ReadLine());
            while (!srTCP.EndOfStream) cbTCP.Items.Add(srTCP.ReadLine());

            srUDP.Close();
            srTCP.Close();
        }



        private void tmrMain_Tick(object sender, EventArgs e)
        {
            string str;
            while ((str = dbg.GetMsg()) != "")
            {
                if (msgBox != null)
                {
                    int cnt1 = msgBox.Lines.Length;
                    if (cnt1 > 10000) msgBox.Clear();
                    msgBox.AppendText(str + "\n");
                }
                msgBox.SelectionStart = msgBox.Text.Length;
                msgBox.ScrollToCaret();
            }


            while ((str = NetMsg.GetMsg()) != "")
            {
                dbg.AddMsg(str);
            }
        }


        private void UdpSend(string str)
        {
            UdpClient udp = new UdpClient();
            byte[] datagram = Encoding.UTF8.GetBytes(str);
            udp.Send(datagram, datagram.Length, "255.255.255.255", 9901);
            udp.Dispose();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            UdpSend(cbUDP.Text.Trim());
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SendMess = cbTCP.Text.Trim();
        }
    }
}
